# Importing Python modules

When importing a module outside from Typon's scope, if a module matching that name exists in Python's scope, then that
module and optionally the specified functions are hoisted to the `import` statement's scope (as in Python).

```py
from numpy import square
import math

if __name__ == "__main__":
    x = [1, 2, 3, 4]
    y: list[int] = square(x)
    print(x, y)
    f: int = math.factorial(5)
    print("5! =", f)
```

Typon cannot currently determine the type signature of imported functions, so they must be either be annotated, or be
used in a context where their type can be fully inferred.

Typon values (C++ objects) are converted to their Python equivalents when passed to Python functions, and vice-versa. 
At the moment, collections are passed by copy; passing by reference is not yet supported.